import 'dart:io';

import 'package:routex_core/routex_core.dart';
import 'package:routex_web/src/http_server_response_impl.dart';


class HttpServerRequestImpl implements HttpServerRequest {
  final HttpServerResponse _response;
  final HttpRequest request;
  String _path;

  HttpServerRequestImpl(this.request)
      : this._response = HttpServerResponseImpl();

  @override
  String path() => _path ?? request.uri.path;

  @override
  HttpMethod method() => _httpMethodFromString(request.method);

  @override
  HttpServerResponse response() => _response;

  @override
  Map<String, dynamic> params() => throw "Not implemented";

  @override
  void setPath(String path) => _path = path;

  @override
  HttpHeaders headers() => request.headers;

  @override
  List<Cookie> cookies() => request.cookies;

  @override
  Map<String, dynamic> getBodyAsJson() => throw "Not implemented";
}

HttpMethod _httpMethodFromString(String method) {
  switch (method.toLowerCase()) {
    case "get":
      return HttpMethod.get;
    case "post":
      return HttpMethod.post;
    case "put":
      return HttpMethod.put;
    case "delete":
      return HttpMethod.delete;
    default:
      return null;
  }


}

void a(HttpRequest req, HttpResponse res){
}

//Component scope: app, user, view, developer
