import 'dart:async';

import 'package:routex_core/routex_core.dart';

class HttpServerResponseImpl implements HttpServerResponse {
  Completer _completer = Completer();

  void fail(Object error) {
    if (!ended()) {
      _completer.completeError(error);
    }
  }

  @override
  bool ended() => _completer.isCompleted;

  @override
  void end(Object value) {
    if (ended()) {
      throw StateError("Request already completed");
    }
    _completer.complete(value);
  }

  @override
  Future materialize() => _completer.future;
}
